[build-system]
requires = ["setuptools>=64", "wheel", "setuptools_scm>=8"]
build-backend = "setuptools.build_meta"

[project]
name = "lhcsmee"
authors = [{ name = "TE-MPE-CB", email = "lhc-signal-monitoring@cern.ch" }]
description = "SIGMON Energy Extraction Analysis"
readme = "README.md"
requires-python = ">=3.11"
dependencies = ["lhcsmapi>=1.8.0rc3", "lhcsmpowering>=1.1.11rc1", "pandas"]
dynamic = ["version"]

[project.urls]
Repository = "https://gitlab.cern.ch/LHCData/lhc-sm-analysis/lhc-sm-ee"

[project.optional-dependencies]
notebook = ["ipympl", "matplotlib", "nbconvert"]

[tool.setuptools_scm]

[tool.black]
line-length = 120
skip-magic-trailing-comma = true

[tool.mypy]
files = ["src"]
warn_unused_configs = true
warn_redundant_casts = true
warn_no_return = true
check_untyped_defs = true

[tool.ruff]
line-length = 120

[tool.ruff.lint]
select = [
    "A",
    "B",
    "E",
    "F",
    "N",
    "NPY",
    "W",
    "I",
    "UP",
    "SIM",
    "BLE",
    "PT",
    "RUF",
] # see https://docs.astral.sh/ruff/rules/


[tool.ruff.lint.per-file-ignores]
"*.ipynb" = [
    "E501", # disable line-too-long in notebooks
    "F821", # disable undefined name in notebooks
]
"*/integration/*" = [
    "E501", # disable line-too-long in notebooks
]

[tool.pytest.ini_options]
addopts = ["--import-mode=importlib"]
pythonpath = "src"
log_cli_level = "INFO"
